
# TODO: Support additional selinux types
%global selinux_variants targeted
%{!?_selinux_policy_version: %global _selinux_policy_version %(%{__sed} -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp 2>/dev/null)}
%global modulename automation-controller

%global tower_version 4.1.1
%global tower_release 2
%global aap_version 2.1.1
%global sdist_tar_name automation-controller-4.1.1-2
%global sdist_source_name automation-controller-4.1.1

%global distro_python_sitelib %(/usr/libexec/platform-python -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")

# Remove brp-python-bytecompile from os_install_post
%global __os_install_post /usr/lib/rpm/brp-compress \
  %{!?__debug_package:/usr/lib/rpm/brp-strip %{__strip}} \
  /usr/lib/rpm/brp-strip-static-archive %{__strip} \
  /usr/lib/rpm/brp-strip-comment-note %{__strip} %{__objdump} \
  /usr/lib/rpm/brp-python-hardlink

Name: automation-controller
Summary: REST api, server, plugins, UI, & CLI client for ansible
Version: %{tower_version}
Release: %{tower_release}%{?dist}
Source0: https://github.com/ansible/tower/archive/%{version}.tar.gz?/%{sdist_tar_name}.tar.gz
Source1: %{modulename}.te
Source2: automation-controller.service
Source3: %{modulename}.fc
Source4: ansible-automation-platform-setup-%{aap_version}-2.tar.gz
Source5: %{name}-cli-%{version}-2.tar.gz
Source6: rsyslog.conf
%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
Source7: automation-controller-4.1.1-2-python-deps.tar.gz
%endif
Provides: automation-controller = %{version}-%{release}
Obsoletes: ansible-tower <= %{version}-%{release}

Group: Development/Libraries
License: Commercial, see https://www.redhat.com/en/about/red-hat-end-user-license-agreements and https://www.redhat.com/en/about/licenses
Url: http://ansible.github.com

# Build Requirements
BuildArch: x86_64

BuildRequires: python38
BuildRequires: python38-devel
BuildRequires: python38-pip

BuildRequires: checkpolicy
BuildRequires: selinux-policy-devel
BuildRequires: hardlink
BuildRequires: sed
BuildRequires: git
BuildRequires: make
BuildRequires: gcc
BuildRequires: bzip2
BuildRequires: postgresql-devel
BuildRequires: libffi-devel
BuildRequires: openssl-devel
BuildRequires: openldap-devel
BuildRequires: libxml2-devel
BuildRequires: libxslt-devel
BuildRequires: xmlsec1-devel, xmlsec1-openssl-devel
BuildRequires: libtool-ltdl-devel
BuildRequires: swig
BuildRequires: libyaml-devel

Requires: automation-controller-server = %{version}-%{release}
Requires: automation-controller-ui = %{version}-%{release}


%description
REST api, server, plugins, Web UI, & CLI client for ansible.

%package server
Summary: Automation Controller REST API
AutoReqProv: no
Obsoletes: ansible-tower-server <= %{version}-%{release}
Requires: automation-controller-venv-tower = %{version}-%{release}
Requires: nginx >= 1:1.18.0
Requires: crontabs
Requires: helm
Requires: sshpass
Requires: supervisor >= 3.0
Requires: git
Requires: git-lfs
Requires: subscription-manager
Requires: subversion
Requires: postgresql
Requires: redis
Requires: sos
Requires: rsync
Requires: rsyslog >= 8.1911
Requires: xmlsec1
Requires: xmlsec1-openssl
Requires: libcgroup-tools
Requires: podman
Requires: crun

# SELinux requirements
%if "%{_selinux_policy_version}" != ""
Requires: python3-libsemanage
%endif

Requires(post): policycoreutils
Requires(post): libselinux-utils
Requires(postun): policycoreutils

%description server
Automation Controller Server and REST API

%package ui
Summary: Automation Controller UI
Requires: automation-controller-server = %{version}-%{release}
Obsoletes: ansible-tower-ui <= %{version}-%{release}

%description ui
UI for Automation Controller

%package setup
Summary: Installer for Automation Controller

%description setup
Installer for Automation Controller

%package venv-tower
Summary: Automation Controller virtual environment
AutoReqProv: no
Obsoletes: ansible-tower-venv-ansible <= %{version}-%{release}
Obsoletes: ansible-tower-venv-tower <= %{version}-%{release}
Requires(pre): python38

# Python dependencies
Provides: bundled(python3dist(adal)) = 1.2.2
Provides: bundled(python3dist(aiohttp)) = 3.6.2
Provides: bundled(python3dist(aioredis)) = 1.3.1
Provides: bundled(python3dist(ansible-runner)) = 2.1.1
Provides: bundled(python3dist(ansiconv)) = 1.0.0
Provides: bundled(python3dist(asciichartpy)) = 1.5.25
Provides: bundled(python3dist(asgiref)) = 3.2.5
Provides: bundled(python3dist(async-timeout)) = 3.0.1
Provides: bundled(python3dist(attrs)) = 19.3.0
Provides: bundled(python3dist(autobahn)) = 20.12.3
Provides: bundled(python3dist(automat)) = 20.2.0
Provides: bundled(python3dist(azure-common)) = 1.1.25
Provides: bundled(python3dist(azure-keyvault)) = 1.1.0
Provides: bundled(python3dist(azure-nspkg)) = 3.0.2
Provides: bundled(python3dist(cachetools)) = 4.0.0
Provides: bundled(python3dist(cffi)) = 1.14.0
Provides: bundled(python3dist(channels)) = 2.4.0
Provides: bundled(python3dist(channels-redis)) = 3.1.0
Provides: bundled(python3dist(chardet)) = 3.0.4
Provides: bundled(python3dist(click)) = 7.1.2
Provides: bundled(python3dist(constantly)) = 15.1.0
Provides: bundled(python3dist(cryptography)) = 2.9.2
Provides: bundled(python3dist(cython)) = 0.29.22
Provides: bundled(python3dist(daphne)) = 2.4.1
Provides: bundled(python3dist(dataclasses)) = 0.6
Provides: bundled(python3dist(defusedxml)) = 0.6.0
Provides: bundled(python3dist(dictdiffer)) = 0.8.1
Provides: bundled(python3dist(distro)) = 1.5.0
Provides: bundled(python3dist(django)) = 2.2.20
Provides: bundled(python3dist(django-auth-ldap)) = 2.1.0
Provides: bundled(python3dist(django-cors-headers)) = 3.7.0
Provides: bundled(python3dist(django-crum)) = 0.7.5
Provides: bundled(python3dist(django-extensions)) = 2.2.9
Provides: bundled(python3dist(django-guid)) = 2.2.0
Provides: bundled(python3dist(django-jsonfield)) = 1.2.0
Provides: bundled(python3dist(django-oauth-toolkit)) = 1.1.3
Provides: bundled(python3dist(django-pglocks)) = 1.0.4
Provides: bundled(python3dist(django-polymorphic)) = 2.1.2
Provides: bundled(python3dist(django-qsstats-magic)) = 1.1.0
Provides: bundled(python3dist(django-radius)) = 1.3.3
Provides: bundled(python3dist(django-redis)) = 4.5.0
Provides: bundled(python3dist(django-solo)) = 1.1.3
Provides: bundled(python3dist(django-split-settings)) = 1.0.0
Provides: bundled(python3dist(django-taggit)) = 1.2.0
Provides: bundled(python3dist(djangorestframework)) = 3.12.1
Provides: bundled(python3dist(djangorestframework-yaml)) = 1.0.3
Provides: bundled(python3dist(docutils)) = 0.16
Provides: bundled(python3dist(future)) = 0.16.0
Provides: bundled(python3dist(gitdb)) = 4.0.2
Provides: bundled(python3dist(gitpython)) = 3.1.7
Provides: bundled(python3dist(google-auth)) = 1.11.3
Provides: bundled(python3dist(hiredis)) = 1.0.1
Provides: bundled(python3dist(hyperlink)) = 20.0.1
Provides: bundled(python3dist(idna)) = 2.9
Provides: bundled(python3dist(incremental)) = 17.5.0
Provides: bundled(python3dist(irc)) = 18.0.0
Provides: bundled(python3dist(isodate)) = 0.6.0
Provides: bundled(python3dist(jaraco.classes)) = 3.1.0
Provides: bundled(python3dist(jaraco.collections)) = 3.0.0
Provides: bundled(python3dist(jaraco.functools)) = 3.0.0
Provides: bundled(python3dist(jaraco.logging)) = 3.0.0
Provides: bundled(python3dist(jaraco.stream)) = 3.0.0
Provides: bundled(python3dist(jaraco.text)) = 3.2.0
Provides: bundled(python3dist(jinja2)) = 2.11.2
Provides: bundled(python3dist(json-log-formatter)) = 0.3.0
Provides: bundled(python3dist(jsonschema)) = 3.2.0
Provides: bundled(python3dist(kubernetes)) = 11.0.0
Provides: bundled(python3dist(lockfile)) = 0.12.2
Provides: bundled(python3dist(lxml)) = 4.5.0
Provides: bundled(python3dist(markdown)) = 3.2.1
Provides: bundled(python3dist(markupsafe)) = 1.1.1
Provides: bundled(python3dist(more-itertools)) = 8.2.0
Provides: bundled(python3dist(msgpack)) = 1.0.0
Provides: bundled(python3dist(msrest)) = 0.6.11
Provides: bundled(python3dist(msrestazure)) = 0.6.3
Provides: bundled(python3dist(multidict)) = 4.7.5
Provides: bundled(python3dist(netaddr)) = 0.7.19
Provides: bundled(python3dist(oauthlib)) = 3.1.0
Provides: bundled(python3dist(openshift)) = 0.11.0
Provides: bundled(python3dist(pexpect)) = 4.7.0
Provides: bundled(python3dist(pkgconfig)) = 1.5.1
Provides: bundled(python3dist(prometheus-client)) = 0.7.1
Provides: bundled(python3dist(psutil)) = 5.8.0
Provides: bundled(python3dist(psycopg2)) = 2.8.4
Provides: bundled(python3dist(ptyprocess)) = 0.6.0
Provides: bundled(python3dist(pyasn1)) = 0.4.8
Provides: bundled(python3dist(pyasn1-modules)) = 0.2.8
Provides: bundled(python3dist(pycparser)) = 2.20
Provides: bundled(python3dist(pygerduty)) = 0.38.2
Provides: bundled(python3dist(pyhamcrest)) = 2.0.2
Provides: bundled(python3dist(pyjwt)) = 1.7.1
Provides: bundled(python3dist(pyopenssl)) = 19.1.0
Provides: bundled(python3dist(pyparsing)) = 2.4.6
Provides: bundled(python3dist(pyrad)) = 2.3
Provides: bundled(python3dist(pyrsistent)) = 0.15.7
Provides: bundled(python3dist(python-daemon)) = 2.2.4
Provides: bundled(python3dist(python-dateutil)) = 2.8.1
Provides: bundled(python3dist(python-dsv-sdk)) = 0.0.1
Provides: bundled(python3dist(python-ldap)) = 3.3.1
Provides: bundled(python3dist(python-string-utils)) = 1.0.0
Provides: bundled(python3dist(python-tss-sdk)) = 1.0.0
Provides: bundled(python3dist(python3-openid)) = 3.1.0
Provides: bundled(python3dist(python3-saml)) = 1.9.0
Provides: bundled(python3dist(pytz)) = 2019.3
Provides: bundled(python3dist(pyyaml)) = 5.4.1
Provides: bundled(python3dist(receptorctl)) = 1.1.1
Provides: bundled(python3dist(redis)) = 3.4.1
Provides: bundled(python3dist(requests)) = 2.23.0
Provides: bundled(python3dist(requests-oauthlib)) = 1.3.0
Provides: bundled(python3dist(rsa)) = 4.0
Provides: bundled(python3dist(ruamel.yaml)) = 0.16.10
Provides: bundled(python3dist(ruamel.yaml.clib)) = 0.2.0
Provides: bundled(python3dist(schedule)) = 0.6.0
Provides: bundled(python3dist(service-identity)) = 18.1.0
Provides: bundled(python3dist(six)) = 1.14.0
Provides: bundled(python3dist(slackclient)) = 1.1.2
Provides: bundled(python3dist(smmap)) = 3.0.1
Provides: bundled(python3dist(social-auth-app-django)) = 3.1.0
Provides: bundled(python3dist(social-auth-core)) = 3.3.1
Provides: bundled(python3dist(sqlparse)) = 0.3.1
Provides: bundled(python3dist(tacacs_plus)) = 1.0
Provides: bundled(python3dist(tempora)) = 2.1.0
Provides: bundled(python3dist(twilio)) = 6.37.0
Provides: bundled(python3dist(twisted)) = 20.3.0
Provides: bundled(python3dist(txaio)) = 20.12.1
Provides: bundled(python3dist(urllib3)) = 1.25.8
Provides: bundled(python3dist(uwsgi)) = 2.0.18
Provides: bundled(python3dist(uwsgitop)) = 0.11
Provides: bundled(python3dist(websocket-client)) = 0.57.0
Provides: bundled(python3dist(wheel)) = 0.36.2
Provides: bundled(python3dist(xmlsec)) = 1.3.3
Provides: bundled(python3dist(yarl)) = 1.4.2
Provides: bundled(python3dist(zope.interface)) = 5.0.0
Provides: bundled(python3dist(pip)) = 21.2.4
Provides: bundled(python3dist(setuptools)) = 58.2.0
# JS dependencies
Provides: bundled(npm(@babel/code-frame)) = 7.12.13
Provides: bundled(npm(@babel/generator)) = 7.14.1
Provides: bundled(npm(@babel/generator/source-map)) = 0.5.7
Provides: bundled(npm(@babel/helper-annotate-as-pure)) = 7.12.13
Provides: bundled(npm(@babel/helper-function-name)) = 7.12.13
Provides: bundled(npm(@babel/helper-get-function-arity)) = 7.12.13
Provides: bundled(npm(@babel/helper-module-imports)) = 7.13.12
Provides: bundled(npm(@babel/helper-split-export-declaration)) = 7.12.13
Provides: bundled(npm(@babel/helper-validator-identifier)) = 7.14.0
Provides: bundled(npm(@babel/highlight)) = 7.14.0
Provides: bundled(npm(@babel/parser)) = 7.14.1
Provides: bundled(npm(@babel/runtime)) = 7.14.0
Provides: bundled(npm(@babel/template)) = 7.12.13
Provides: bundled(npm(@babel/traverse)) = 7.14.0
Provides: bundled(npm(@babel/types)) = 7.14.1
Provides: bundled(npm(@emotion/is-prop-valid)) = 0.8.8
Provides: bundled(npm(@emotion/memoize)) = 0.7.4
Provides: bundled(npm(@emotion/stylis)) = 0.8.5
Provides: bundled(npm(@emotion/unitless)) = 0.7.5
Provides: bundled(npm(@lingui/core)) = 3.9.0
Provides: bundled(npm(@lingui/react)) = 3.9.0
Provides: bundled(npm(@patternfly/patternfly)) = 4.102.1
Provides: bundled(npm(@patternfly/react-core)) = 4.121.1
Provides: bundled(npm(@patternfly/react-core/@patternfly/react-icons)) = 4.11.17
Provides: bundled(npm(@patternfly/react-icons)) = 4.7.22
Provides: bundled(npm(@patternfly/react-styles)) = 4.11.16
Provides: bundled(npm(@patternfly/react-table)) = 4.26.7
Provides: bundled(npm(@patternfly/react-table/@patternfly/react-core)) = 4.157.3
Provides: bundled(npm(@patternfly/react-table/@patternfly/react-icons)) = 4.11.17
Provides: bundled(npm(@patternfly/react-table/tslib)) = 2.3.1
Provides: bundled(npm(@patternfly/react-tokens)) = 4.12.18
Provides: bundled(npm(@types/parse-json)) = 4.0.0
Provides: bundled(npm(ace-builds)) = 1.4.12
Provides: bundled(npm(ansi-regex)) = 6.0.1
Provides: bundled(npm(ansi-styles)) = 3.2.1
Provides: bundled(npm(ansi-to-html)) = 0.7.2
Provides: bundled(npm(argparse)) = 1.0.10
Provides: bundled(npm(attr-accept)) = 1.1.3
Provides: bundled(npm(axios)) = 0.22.0
Provides: bundled(npm(babel-plugin-macros)) = 3.1.0
Provides: bundled(npm(babel-plugin-styled-components)) = 1.12.0
Provides: bundled(npm(babel-plugin-syntax-jsx)) = 6.18.0
Provides: bundled(npm(callsites)) = 3.1.0
Provides: bundled(npm(camelize)) = 1.0.0
Provides: bundled(npm(chalk)) = 2.4.2
Provides: bundled(npm(clsx)) = 1.1.1
Provides: bundled(npm(codemirror)) = 5.61.0
Provides: bundled(npm(color-convert)) = 1.9.3
Provides: bundled(npm(color-name)) = 1.1.3
Provides: bundled(npm(colorette)) = 1.2.2
Provides: bundled(npm(commander)) = 2.20.3
Provides: bundled(npm(core-js)) = 2.6.12
Provides: bundled(npm(cosmiconfig)) = 7.0.0
Provides: bundled(npm(css-color-keywords)) = 1.0.0
Provides: bundled(npm(css-to-react-native)) = 3.0.0
Provides: bundled(npm(css-to-react-native/postcss-value-parser)) = 4.1.0
Provides: bundled(npm(csstype)) = 3.0.8
Provides: bundled(npm(d3)) = 6.7.0
Provides: bundled(npm(d3-array)) = 2.12.1
Provides: bundled(npm(d3-axis)) = 2.1.0
Provides: bundled(npm(d3-brush)) = 2.1.0
Provides: bundled(npm(d3-chord)) = 2.0.0
Provides: bundled(npm(d3-color)) = 2.0.0
Provides: bundled(npm(d3-contour)) = 2.0.0
Provides: bundled(npm(d3-delaunay)) = 5.3.0
Provides: bundled(npm(d3-dispatch)) = 2.0.0
Provides: bundled(npm(d3-drag)) = 2.0.0
Provides: bundled(npm(d3-dsv)) = 2.0.0
Provides: bundled(npm(d3-ease)) = 2.0.0
Provides: bundled(npm(d3-fetch)) = 2.0.0
Provides: bundled(npm(d3-force)) = 2.1.1
Provides: bundled(npm(d3-format)) = 2.0.0
Provides: bundled(npm(d3-geo)) = 2.0.2
Provides: bundled(npm(d3-hierarchy)) = 2.0.0
Provides: bundled(npm(d3-interpolate)) = 2.0.1
Provides: bundled(npm(d3-path)) = 2.0.0
Provides: bundled(npm(d3-polygon)) = 2.0.0
Provides: bundled(npm(d3-quadtree)) = 2.0.0
Provides: bundled(npm(d3-random)) = 2.2.2
Provides: bundled(npm(d3-scale)) = 3.3.0
Provides: bundled(npm(d3-scale-chromatic)) = 2.0.0
Provides: bundled(npm(d3-selection)) = 2.0.0
Provides: bundled(npm(d3-shape)) = 2.1.0
Provides: bundled(npm(d3-time)) = 2.1.1
Provides: bundled(npm(d3-time-format)) = 3.0.0
Provides: bundled(npm(d3-timer)) = 2.0.0
Provides: bundled(npm(d3-transition)) = 2.0.0
Provides: bundled(npm(d3-zoom)) = 2.0.0
Provides: bundled(npm(dagre)) = 0.8.5
Provides: bundled(npm(debug)) = 4.3.1
Provides: bundled(npm(deepmerge)) = 2.2.1
Provides: bundled(npm(delaunator)) = 4.0.1
Provides: bundled(npm(diff-match-patch)) = 1.0.5
Provides: bundled(npm(dom-helpers)) = 5.2.1
Provides: bundled(npm(dom-serializer)) = 1.3.1
Provides: bundled(npm(domelementtype)) = 2.2.0
Provides: bundled(npm(domhandler)) = 4.2.0
Provides: bundled(npm(domutils)) = 2.6.0
Provides: bundled(npm(entities)) = 2.2.0
Provides: bundled(npm(error-ex)) = 1.3.2
Provides: bundled(npm(escape-string-regexp)) = 1.0.5
Provides: bundled(npm(esprima)) = 4.0.1
Provides: bundled(npm(file-selector)) = 0.1.19
Provides: bundled(npm(file-selector/tslib)) = 2.2.0
Provides: bundled(npm(focus-trap)) = 6.2.2
Provides: bundled(npm(follow-redirects)) = 1.14.4
Provides: bundled(npm(formik)) = 2.2.9
Provides: bundled(npm(function-bind)) = 1.1.1
Provides: bundled(npm(globals)) = 11.12.0
Provides: bundled(npm(graphlib)) = 2.1.8
Provides: bundled(npm(has)) = 1.0.3
Provides: bundled(npm(has-ansi)) = 5.0.1
Provides: bundled(npm(has-flag)) = 3.0.0
Provides: bundled(npm(history)) = 4.10.1
Provides: bundled(npm(hoist-non-react-statics)) = 3.3.2
Provides: bundled(npm(html-entities)) = 2.3.2
Provides: bundled(npm(htmlparser2)) = 6.1.0
Provides: bundled(npm(iconv-lite)) = 0.4.24
Provides: bundled(npm(import-fresh)) = 3.3.0
Provides: bundled(npm(internmap)) = 1.0.1
Provides: bundled(npm(is-arrayish)) = 0.2.1
Provides: bundled(npm(is-core-module)) = 2.4.0
Provides: bundled(npm(is-plain-object)) = 5.0.0
Provides: bundled(npm(isarray)) = 0.0.1
Provides: bundled(npm(js-tokens)) = 4.0.0
Provides: bundled(npm(js-yaml)) = 3.14.1
Provides: bundled(npm(jsesc)) = 2.5.2
Provides: bundled(npm(json-parse-even-better-errors)) = 2.3.1
Provides: bundled(npm(klona)) = 2.0.4
Provides: bundled(npm(lines-and-columns)) = 1.1.6
Provides: bundled(npm(lodash)) = 4.17.21
Provides: bundled(npm(lodash-es)) = 4.17.21
Provides: bundled(npm(lodash.get)) = 4.4.2
Provides: bundled(npm(lodash.isequal)) = 4.5.0
Provides: bundled(npm(loose-envify)) = 1.4.0
Provides: bundled(npm(luxon)) = 2.0.1
Provides: bundled(npm(make-plural)) = 6.2.2
Provides: bundled(npm(messageformat-parser)) = 4.1.3
Provides: bundled(npm(mini-create-react-context)) = 0.4.1
Provides: bundled(npm(ms)) = 2.1.2
Provides: bundled(npm(nanoid)) = 3.1.23
Provides: bundled(npm(object-assign)) = 4.1.1
Provides: bundled(npm(parent-module)) = 1.0.1
Provides: bundled(npm(parse-json)) = 5.2.0
Provides: bundled(npm(parse-srcset)) = 1.0.2
Provides: bundled(npm(path-parse)) = 1.0.7
Provides: bundled(npm(path-to-regexp)) = 1.8.0
Provides: bundled(npm(path-type)) = 4.0.0
Provides: bundled(npm(popper.js)) = 1.16.1
Provides: bundled(npm(postcss)) = 8.2.15
Provides: bundled(npm(prop-types)) = 15.7.2
Provides: bundled(npm(prop-types-extra)) = 1.1.1
Provides: bundled(npm(react)) = 16.14.0
Provides: bundled(npm(react-ace)) = 9.4.0
Provides: bundled(npm(react-dom)) = 16.14.0
Provides: bundled(npm(react-dropzone)) = 9.0.0
Provides: bundled(npm(react-error-boundary)) = 3.1.3
Provides: bundled(npm(react-fast-compare)) = 2.0.4
Provides: bundled(npm(react-is)) = 16.13.1
Provides: bundled(npm(react-lifecycles-compat)) = 3.0.4
Provides: bundled(npm(react-router)) = 5.2.0
Provides: bundled(npm(react-router-dom)) = 5.2.0
Provides: bundled(npm(react-virtualized)) = 9.22.3
Provides: bundled(npm(regenerator-runtime)) = 0.13.7
Provides: bundled(npm(resolve)) = 1.20.0
Provides: bundled(npm(resolve-from)) = 4.0.0
Provides: bundled(npm(resolve-pathname)) = 3.0.0
Provides: bundled(npm(rrule)) = 2.6.4
Provides: bundled(npm(rrule/luxon)) = 1.28.0
Provides: bundled(npm(rw)) = 1.3.3
Provides: bundled(npm(safer-buffer)) = 2.1.2
Provides: bundled(npm(sanitize-html)) = 2.4.0
Provides: bundled(npm(sanitize-html/deepmerge)) = 4.2.2
Provides: bundled(npm(sanitize-html/escape-string-regexp)) = 4.0.0
Provides: bundled(npm(scheduler)) = 0.19.1
Provides: bundled(npm(shallowequal)) = 1.1.0
Provides: bundled(npm(source-map)) = 0.6.1
Provides: bundled(npm(sprintf-js)) = 1.0.3
Provides: bundled(npm(styled-components)) = 5.3.0
Provides: bundled(npm(supports-color)) = 5.5.0
Provides: bundled(npm(tabbable)) = 5.2.0
Provides: bundled(npm(tiny-invariant)) = 1.1.0
Provides: bundled(npm(tiny-warning)) = 1.0.3
Provides: bundled(npm(tippy.js)) = 5.1.2
Provides: bundled(npm(to-fast-properties)) = 2.0.0
Provides: bundled(npm(tslib)) = 1.13.0
Provides: bundled(npm(value-equal)) = 1.0.1
Provides: bundled(npm(warning)) = 4.0.3
Provides: bundled(npm(yaml)) = 1.10.2

%description venv-tower
Automation Controller virtual environment

%package cli
Summary: Package for Automation Controller CLI
AutoReqProv: no
Obsoletes: ansible-tower-cli <= %{version}-%{release}
Requires: python38
Requires: python38-setuptools
Requires: python38-requests
Requires: python38-pyyaml

%description cli
Package for Automation Controller CLI

%prep
%setup -q -n %{sdist_source_name}

tar -xf %{SOURCE4}

mkdir SELinux
cp -p %{SOURCE1} %{SOURCE3} SELinux/

%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
tar -xf %{SOURCE7}
%endif


%build
# Disable debuginfo packages
%define _enable_debug_package 0
%define debug_package %{nil}


%install

export LANG=en_US.UTF-8 LANGUAGE=en_US.en LC_ALL=en_US.UTF-8

mkdir -p %{buildroot}/var/lib/awx
mv ansible-automation-platform-setup-%{aap_version}-2/ %{buildroot}/var/lib/awx/setup

mkdir -p %{buildroot}/var/lib/awx/rsyslog
mkdir -p %{buildroot}/var/lib/awx/rsyslog/conf.d
cp %{SOURCE6} %{buildroot}/var/lib/awx/rsyslog/rsyslog.conf

export PYTHON=python3.8

# Create folder for the virtualenvs
export VENV_BASE=venv
mkdir -p $VENV_BASE

# Fix m2crypto builds (details at http://pkgs.fedoraproject.org/cgit/m2crypto.git/tree/m2crypto.spec)
export SWIG_FEATURES="-cpperraswarn"

%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
export PIP_OPTIONS="--find-links=tower/requirements/vendor --no-index"

cat >> setup.cfg <<EOF
[easy_install]
index_url = ''
find_links = file://$PWD/tower/requirements/vendor/
EOF

cp setup.cfg ~/.pydistutils.cfg
%endif

# Install the awxkit package
python3.8 -m pip install %{SOURCE5} --root %{buildroot} --no-deps

export CFLAGS="-DXMLSEC_NO_SIZE_T"
# Install the Tower venv and requirements
%{__make} requirements_awx

python3.8 setup.py build

# Build SELinux policy package (.pp)
pushd SELinux
for selinuxvariant in %{selinux_variants}; do
    make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile
    mv %{modulename}.pp %{modulename}.pp.${selinuxvariant}
    make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile clean
done
popd

# Move site-packages to the buildroot
mkdir -p %{buildroot}/var/lib/awx/venv/awx/lib/python3.8
mv venv/awx/lib/python3.8/site-packages %{buildroot}/var/lib/awx/venv/awx/lib/python3.8/site-packages

# Move bin files
mkdir -p %{buildroot}/var/lib/awx/venv/awx/bin
rm -f %{buildroot}/var/lib/awx/venv/awx/bin/pip*
cp -rp venv/awx/bin/pip* %{buildroot}/var/lib/awx/venv/awx/bin/
mv venv/awx/bin/uwsgi %{buildroot}/var/lib/awx/venv/awx/bin/uwsgi
mv venv/awx/bin/uwsgitop %{buildroot}/var/lib/awx/venv/awx/bin/uwsgitop
mv venv/awx/bin/daphne %{buildroot}/var/lib/awx/venv/awx/bin/daphne
mv venv/awx/bin/ansible-runner %{buildroot}/var/lib/awx/venv/awx/bin/ansible-runner
mv venv/awx/bin/receptorctl %{buildroot}/var/lib/awx/venv/awx/bin/receptorctl

# Replace python interpreter shebang to known destination system paths
PYTHON_INTERPRETER='#!/var/lib/awx/venv/awx/bin/python'
sed -i "1 s|^.*$|$PYTHON_INTERPRETER|" %{buildroot}/var/lib/awx/venv/awx/bin/pip*

PYTHON_INTERPRETER='#!/usr/bin/awx-python'
sed -i "1 s|^.*$|$PYTHON_INTERPRETER|" %{buildroot}/var/lib/awx/venv/awx/bin/daphne

PYTHON_INTERPRETER='#!/usr/bin/awx-python'
sed -i "1 s|^.*$|$PYTHON_INTERPRETER|" %{buildroot}/var/lib/awx/venv/awx/bin/ansible-runner

PYTHON_INTERPRETER='#!/usr/bin/awx-python'
sed -i "1 s|^.*$|$PYTHON_INTERPRETER|" %{buildroot}/var/lib/awx/venv/awx/bin/receptorctl

# Install to the buildroot (non virtualenv)
mkdir -p %{buildroot}/rpm-tmp

python3.8 setup.py install --skip-build --no-compile --root=%{buildroot}/rpm-tmp

# Move files from rpm-tmp folder to the appropriate base folders
mv %{buildroot}/rpm-tmp/usr/lib/python3.8/site-packages/* %{buildroot}/var/lib/awx/venv/awx/lib/python3.8/site-packages

mkdir -p %{buildroot}/usr/bin
mv %{buildroot}/rpm-tmp/usr/bin/* %{buildroot}/usr/bin

# Symlinks to old tower-python and tower-manage executables
ln -s /usr/bin/awx-manage %{buildroot}/%{_bindir}/tower-manage
ln -s /usr/bin/awx-python %{buildroot}/%{_bindir}/tower-python

mkdir -p %{buildroot}/usr/share/sosreport/sos/plugins
mv %{buildroot}/rpm-tmp/usr/share/sosreport/sos/plugins/* %{buildroot}/usr/share/sosreport/sos/plugins

mkdir -p %{buildroot}/usr/share/doc/ansible-tower
mv %{buildroot}/rpm-tmp/usr/share/doc/awx/* %{buildroot}/usr/share/doc/ansible-tower

mkdir -p %{buildroot}/lib/systemd/system
install -m 644 %{SOURCE2} %{buildroot}/lib/systemd/system

mkdir -p %{buildroot}/usr/share/awx
mv %{buildroot}/rpm-tmp/usr/share/awx/* %{buildroot}/usr/share/awx

rm -rf %{buildroot}/rpm-tmp

# Create other needed folders
install -d %{buildroot}/%{_sysconfdir}/tower/
install -d -m 0750 %{buildroot}/var/log/tower
install -d -m 0750 %{buildroot}/var/lib/awx/job_status
install -d %{buildroot}/%{_datadir}/awx
install -d -m 2775 %{buildroot}/var/run/tower

# SELinux setup
for selinuxvariant in %{selinux_variants}
do
  install -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
  install -p -m 644 SELinux/%{modulename}.pp.${selinuxvariant} \
    %{buildroot}%{_datadir}/selinux/${selinuxvariant}/%{modulename}.pp
done
/usr/sbin/hardlink -cv %{buildroot}%{_datadir}/selinux

%clean
rm -rf %{buildroot}

%preun
automation-controller-service stop

%pre server
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx
# Remove old links
rm -f %{distro_python_sitelib}/sos/plugins/tower.py >/dev/null 2>&1 || :
rm -f %{distro_python_sitelib}/sos/report/plugins/tower.py >/dev/null 2>&1 || :

%post server
# Generate or reuse key file
if [ ! -f /etc/tower/SECRET_KEY ]; then
python3.8 -c 'import base64, os; f = open("/etc/tower/SECRET_KEY", "w"); f.write(base64.encodebytes(os.urandom(33)).decode().rstrip()); f.close()'
fi
chown root:awx /etc/tower/SECRET_KEY
chmod 640 /etc/tower/SECRET_KEY

# Create sosreport symlinks
ln -s /usr/share/sosreport/sos/plugins/controller.py  %{distro_python_sitelib}/sos/plugins/ || :
ln -s /usr/share/sosreport/sos/plugins/controller.py  %{distro_python_sitelib}/sos/report/plugins/ || :

# allow needed nginx access
for selinuxvariant in %{selinux_variants} ; do
    semodule -s ${selinuxvariant} -i %{_datadir}/selinux/${selinuxvariant}/%{modulename}.pp
done
/sbin/fixfiles -R %{modulename} restore || :
/sbin/restorecon -R /var/lib/awx/venv /var/lib/awx/job_status /var/run/tower
chown -R nginx:nginx /var/run/tower || :
if [ $1 -eq 1 ] ; then
        # Initial installation
        systemctl --no-reload preset automation-controller.service >/dev/null 2>&1 || :
fi

%preun server
if [ $1 -eq 0 ] ; then
        # Package removal, not upgrade
        systemctl --no-reload disable --now automation-controller.service >/dev/null 2>&1 || :
fi

%postun server
sed -i -e '/^# START AWX/,/^# END AWX/d' /etc/supervisord.conf
# Remove custom policy
if [ $1 -eq 0 ] ; then
    for selinuxvariant in %{selinux_variants} ; do
        /usr/sbin/semodule -s ${selinuxvariant} -r %{modulename} 2> /dev/null || :
    done
    # Remove sosreport symlinks
    rm -f %{distro_python_sitelib}/sos/plugins/controller.py || :
    rm -f %{distro_python_sitelib}/sos/report/plugins/controller.py || :
fi

%pre venv-tower
systemctl stop supervisord >/dev/null 2>&1 || :
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx
python3.8 -m venv --clear /var/lib/awx/venv/awx

%files
%defattr(-,root,root)

%files server
%exclude /var/lib/awx/setup
%exclude /var/lib/awx/venv
%defattr(-,root,root)
%doc %{_datadir}/doc/ansible-tower
%{_bindir}/awx-manage
%{_bindir}/awx-python
%{_bindir}/tower-manage
%{_bindir}/tower-python
%{_bindir}/automation-controller-service
%{_bindir}/failure-event-handler
/lib/systemd/system/automation-controller.service
%attr(2775,nginx,nginx) /var/run/tower
%dir %attr(0755,awx,awx) /var/lib/awx
%dir %attr(0755,awx,awx) /var/lib/awx/rsyslog
%attr(0750,awx,awx) /var/log/tower
/var/lib/awx/[^j]*
%attr(0750,awx,awx) /var/lib/awx/rsyslog/rsyslog.conf
%attr(0750,awx,awx) /var/lib/awx/job_status
%{_datadir}/selinux/*/%{modulename}.pp
%{_datadir}/awx/
%{_datadir}/sosreport/sos/plugins/controller.py*
%config(noreplace) %attr(-,root,awx) %{_sysconfdir}/tower

%files ui
%defattr(-,root,root)
/var/lib/awx/venv/awx/lib/python3.8/site-packages/awx/static

%files setup
%defattr(-,root,root)
/var/lib/awx/setup
%{_bindir}/ansible-tower-setup

%files venv-tower
%exclude /var/lib/awx/venv/awx/lib/python3.8/site-packages/awx/static
%exclude /var/lib/awx/venv/awx/lib/python3.8/site-packages/awx/ui/static
%defattr(-,root,root)
/var/lib/awx/venv/awx

%files cli
%exclude /usr/bin/akit
/usr/bin/awx
%{_prefix}/lib/python3.8/site-packages/awxkit*

%changelog
* Wed Jan 12 2022 Satoe Imaishi <simaishi@redhat.com> - 4.1.1-1
- 4.1.1 release

* Mon Nov 22 2021 Satoe Imaishi <simaishi@redhat.com> - 4.1.0-1
- 4.1.0 release

* Wed Jul 07 2021 Satoe Imaishi <simaishi@redhat.com> - 4.0.0-1
- 4.0.0 release

* Mon May 18 2020 Shane McDonald <shanemcd@redhat.com>
- 3.7.0 release

* Wed Apr 22 2020 Shane McDonald <shanemcd@redhat.com>
- 3.6.4 release

* Wed Apr 22 2020 Shane McDonald <shanemcd@redhat.com>
- 3.5.6 release

* Thu Feb 20 2020 Yanis Guenane <yguenane@redhat.com>
- 3.6.3 release

* Thu Feb 20 2020 Yanis Guenane <yguenane@redhat.com>
- 3.5.5 release

* Mon Dec 16 2019 Shane McDonald <shanemcd@redhat.com>
- 3.6.2 release

* Mon Dec 16 2019 Shane McDonald <shanemcd@redhat.com>
- 3.5.4 release

* Mon Nov 25 2019 Shane McDonald <shanemcd@redhat.com>
- 3.6.1 release

* Wed Nov 13 2019 Shane McDonald <shanemcd@redhat.com>
- 3.6.0 release

* Thu Sep 19 2019 Shane McDonald <shanemcd@redhat.com>
- 3.5.3 release

* Wed Aug 14 2019 Shane McDonald <shanemcd@redhat.com>
- 3.5.2 release

* Wed Jul 10 2019 Shane McDonald <shanemcd@redhat.com>
- 3.5.1 release

* Wed May 29 2019 Shane McDonald <shanemcd@redhat.com>
- 3.5.0 release

* Tue Mar 26 2019 Shane McDonald <shanemcd@redhat.com>
- 3.4.3 release

* Wed Mar 6 2019 Shane McDonald <shanemcd@redhat.com>
- 3.4.2 release

* Thu Jan 24 2019 Shane McDonald <shanemcd@redhat.com>
- 3.4.1 release

* Thu Jan 24 2019 Shane McDonald <shanemcd@redhat.com>
- 3.3.4 release

* Wed Jan 9 2019 Shane McDonald <shanemcd@redhat.com>
- 3.4.0 release

* Tue Dec 18 2018 Shane McDonald <shanemcd@redhat.com>
- 3.3.3 release

* Thu Dec 6 2018 Shane McDonald <shanemcd@redhat.com>
- 3.3.2 release

* Thu Oct 25 2018 Shane McDonald <shanemcd@redhat.com>
- 3.3.1 release

* Wed Sep 12 2018 Shane McDonald <shanemcd@redhat.com>
- 3.3.0 release

* Fri Aug 10 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.6 release

* Fri May 11 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.5 release

* Thu Apr 5 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.4 release

* Tue Feb 20 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.3 release

* Tue Feb 20 2018 Shane McDonald <shanemcd@redhat.com>
- 3.2.2 release

* Thu Dec 7 2017 Shane McDonald <shanemcd@redhat.com>
- 3.2.2 release

* Wed Oct 11 2017 Shane McDonald <shanemcd@redhat.com>
- 3.2.1 release

* Sun Oct 1 2017 Shane McDonald <shanemcd@redhat.com>
- 3.2.0 release

* Sun Sep 17 2017 Shane McDonald <shanemcd@redhat.com>
- 3.1.5 release

* Mon Jul 10 2017 Shane McDonald <shanemcd@redhat.com>
- 3.1.4 release

* Mon May 1 2017 Matthew Jones <matburt@redhat.com>
- 3.1.3 release

* Fri Apr 7 2017 Matthew Jones <matburt@redhat.com>
- 3.1.2-2 release

* Fri Mar 31 2017 Matthew Jones <matburt@redhat.com>
- 3.1.2 release

* Tue Mar 28 2017 Matthew Jones <matburt@redhat.com>
- 3.1.1 release

* Mon Feb 27 2017 Matthew Jones <matburt@redhat.com>
- 3.1.0 release

* Fri Oct 28 2016 Matthew Jones <matburt@redhat.com>
- 3.0.3 release

* Wed Aug 31 2016 Matthew Jones <matburt@redhat.com>
- 3.0.2 release

* Fri Jul 29 2016 Matthew Jones <matburt@redhat.com>
- 3.0.1 release

* Tue Jul 19 2016 Matthew Jones <matburt@redhat.com>
- 3.0.0 release

* Wed Apr 20 2016 Matthew Jones <matburt@redhat.com>
- 2.4.5 release

* Fri Feb 19 2016 Matthew Jones <matburt@redhat.com>
- 2.4.4 release

* Wed Dec 16 2015 Matthew Jones <mjones@ansible.com>
- 2.4.3 release

* Wed Dec 9 2015 Matthew Jones <mjones@ansible.com>
- 2.4.2 release

* Thu Nov 19 2015 Matthew Jones <mjones@ansible.com>
- 2.4.1 release

* Wed Nov 18 2015 Matthew Jones <mjones@ansible.com>
- 2.4.0 release

* Fri Oct 2 2015 Matthew Jones <mjones@ansible.com>
- 2.3.1 release

* Tue Sep 22 2015 Matthew Jones <mjones@ansible.com>
- 2.3.0 release

* Wed Aug 19 2015 Matthew Jones <mjones@ansible.com>
- 2.2.2 release

* Wed Aug 12 2015 Matthew Jones <mjones@ansible.com>
- 2.2.1 release

* Tue Jul 14 2015 Matthew Jones <mjones@ansible.com>
- 2.2.0 release

* Tue Jun 23 2015 Chris Meyers <cmeyers@ansible.com>
- 2.1.6 release

* Fri Jun 12 2015 Chris Meyers <cmeyers@ansible.com>
- 2.1.5 release

* Fri May 1 2015 Matthew Jones <mjones@ansible.com>
- 2.1.4 release

* Tue Apr 14 2015 Matthew Jones <mjones@ansible.com>
- 2.1.3 release

* Wed Mar 25 2015 Matthew Jones <mjones@ansible.com>
- 2.1.2 release

* Wed Feb 04 2015 Matthew Jones <mjones@ansible.com>
- 2.1.1 release

* Thu Jan 08 2015 Matthew Jones <mjones@ansible.com>
- 2.1.0 release

* Wed Dec 10 2014 Matthew Jones <mjones@ansible.com>
- 2.0.5 release

* Fri Nov 21 2014 James Laska <jlaska@ansible.com>
- 2.0.4 release

* Fri Nov 14 2014 James Laska <jlaska@ansible.com>
- 2.0.3 release

* Mon Oct 6 2014 James Laska <jlaska@ansible.com>
- 2.0.2 release

* Thu Sep 4 2014 James Laska <jlaska@ansible.com>
- 2.0.1 release

* Tue Aug 19 2014 James Laska <jlaska@ansible.com>
- 2.0.0 release

* Mon Jul 28 2014 James Laska <jlaska@ansible.com>
- 1.4.12 release

* Sun May 11 2014 James Laska <jlaska@ansible.com>
- 1.4.11 release

* Wed Apr 23 2014 James Laska <jlaska@ansible.com>
- 1.4.10 release

* Thu Apr 17 2014 James Laska <jlaska@ansible.com>
- 1.4.9 release

* Tue Apr 8 2014 James Laska <jlaska@ansible.com>
- 1.4.8 release

* Wed Jan 29 2014 James Laska <jlaska@ansible.com>
- 1.4.5 release

* Mon Jun 10 2013 James Cammarata <jimi@sngx.net>
- Initial RPM packaging for awx
